require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_MMZONE_H_)) {
    eval 'sub _ASM_MMZONE_H_ {1;}' unless defined(&_ASM_MMZONE_H_);
    require 'asm/smp.ph';
    if(defined(&CONFIG_NUMA)) {
	eval 'sub NODE_DATA {
	    my($nid) = @_;
    	    eval q(( $node_data[$nid]));
	}' unless defined(&NODE_DATA);
	if(defined(&CONFIG_X86_NUMAQ)) {
	    require 'asm/numaq.ph';
	}
 elsif(defined( &CONFIG_ACPI_SRAT) ) {
	    require 'asm/srat.ph';
	}
	if(defined(&CONFIG_X86_NUMAQ)) {
	}
 elsif(defined( &CONFIG_ACPI_SRAT)) {
	}
    } else {
	eval 'sub get_memcfg_numa { &get_memcfg_numa_flat;}' unless defined(&get_memcfg_numa);
	eval 'sub get_zholes_size {
	    my($n) = @_;
    	    eval q((0));
	}' unless defined(&get_zholes_size);
    }
    if(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub MAX_NR_PAGES {16777216;}' unless defined(&MAX_NR_PAGES);
	eval 'sub MAX_ELEMENTS {256;}' unless defined(&MAX_ELEMENTS);
	eval 'sub PAGES_PER_ELEMENT {( &MAX_NR_PAGES/ &MAX_ELEMENTS);}' unless defined(&PAGES_PER_ELEMENT);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pfn_to_nid {
	    my($pfn) = @_;
    	    eval q({ });
	}' unless defined(&pfn_to_nid);
	eval 'sub node_start_pfn {
	    my($nid) = @_;
    	    eval q(( &NODE_DATA($nid)-> &node_start_pfn));
	}' unless defined(&node_start_pfn);
	eval 'sub node_end_pfn {
	    my($nid) = @_;
    	    eval q(({  &pg_data_t * &__pgdat =  &NODE_DATA($nid);  ($__pgdat->{node_start_pfn}) +  ($__pgdat->{node_spanned_pages}); }));
	}' unless defined(&node_end_pfn);
	eval 'sub kern_addr_valid {
	    my($kaddr) = @_;
    	    eval q((0));
	}' unless defined(&kern_addr_valid);
	if(defined(&CONFIG_X86_NUMAQ)) {
	    eval 'sub pfn_valid {
	        my($pfn) = @_;
    		eval q((($pfn) <  &num_physpages));
	    }' unless defined(&pfn_valid);
	} else {
	    eval 'sub pfn_valid {
	        my($pfn) = @_;
    		eval q({ \'int\'  &nid =  &pfn_to_nid($pfn);  &if ( &nid >= 0) ($pfn <  &node_end_pfn( &nid)); 0; });
	    }' unless defined(&pfn_valid);
	}
    }
    if(defined(&CONFIG_NEED_MULTIPLE_NODES)) {
	eval 'sub reserve_bootmem {
	    my($addr, $size) = @_;
    	    eval q( &reserve_bootmem_node( &NODE_DATA(0), ($addr), ($size)));
	}' unless defined(&reserve_bootmem);
	eval 'sub alloc_bootmem {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &SMP_CACHE_BYTES,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem);
	eval 'sub alloc_bootmem_low {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &SMP_CACHE_BYTES, 0));
	}' unless defined(&alloc_bootmem_low);
	eval 'sub alloc_bootmem_pages {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &PAGE_SIZE,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem_pages);
	eval 'sub alloc_bootmem_low_pages {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &PAGE_SIZE, 0));
	}' unless defined(&alloc_bootmem_low_pages);
	eval 'sub alloc_bootmem_node {
	    my($ignore, $x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &SMP_CACHE_BYTES,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem_node);
	eval 'sub alloc_bootmem_pages_node {
	    my($ignore, $x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &PAGE_SIZE,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem_pages_node);
	eval 'sub alloc_bootmem_low_pages_node {
	    my($ignore, $x) = @_;
    	    eval q( &__alloc_bootmem_node( &NODE_DATA(0), ($x),  &PAGE_SIZE, 0));
	}' unless defined(&alloc_bootmem_low_pages_node);
    }
}
1;
