require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_I386_UNWIND_H)) {
    eval 'sub _ASM_I386_UNWIND_H {1;}' unless defined(&_ASM_I386_UNWIND_H);
    if(defined(&CONFIG_STACK_UNWIND)) {
	require 'linux/sched.ph';
	require 'asm/fixmap.ph';
	require 'asm/ptrace.ph';
	require 'asm/uaccess.ph';
	eval 'sub UNW_PC {
	    my($frame) = @_;
    	    eval q(($frame)-> ($regs->{eip}));
	}' unless defined(&UNW_PC);
	eval 'sub UNW_SP {
	    my($frame) = @_;
    	    eval q(($frame)-> ($regs->{esp}));
	}' unless defined(&UNW_SP);
	if(defined(&CONFIG_FRAME_POINTER)) {
	    eval 'sub UNW_FP {
	        my($frame) = @_;
    		eval q(($frame)-> ($regs->{ebp}));
	    }' unless defined(&UNW_FP);
	    eval 'sub FRAME_RETADDR_OFFSET {4;}' unless defined(&FRAME_RETADDR_OFFSET);
	    eval 'sub FRAME_LINK_OFFSET {0;}' unless defined(&FRAME_LINK_OFFSET);
	    eval 'sub STACK_BOTTOM {
	        my($tsk) = @_;
    		eval q( &STACK_LIMIT(($tsk)-> ($thread->{esp0})));
	    }' unless defined(&STACK_BOTTOM);
	    eval 'sub STACK_TOP {
	        my($tsk) = @_;
    		eval q((($tsk)-> ($thread->{esp0})));
	    }' unless defined(&STACK_TOP);
	}
	eval 'sub STACK_LIMIT {
	    my($ptr) = @_;
    	    eval q(((($ptr) - 1) & ~( &THREAD_SIZE - 1)));
	}' unless defined(&STACK_LIMIT);
	eval 'sub UNW_REGISTER_INFO { &PTREGS_INFO( &eax),  &PTREGS_INFO( &ecx),  &PTREGS_INFO( &edx),  &PTREGS_INFO( &ebx),  &PTREGS_INFO( &esp),  &PTREGS_INFO( &ebp),  &PTREGS_INFO( &esi),  &PTREGS_INFO( &edi),  &PTREGS_INFO( &eip);}' unless defined(&UNW_REGISTER_INFO);
	eval 'sub arch_unw_init_frame_info {
	    my($info,$regs) = @_;
    	    eval q({  &if ( &user_mode_vm($regs))  ($info->{regs}) = *$regs;  &else {  &memcpy( ($info->{regs}), $regs,  &offsetof(\'struct pt_regs\',  &esp));  ($info->{regs}->{esp}) =  ($regs->{esp});  ($info->{regs}->{xss}) =  &__KERNEL_DS; } });
	}' unless defined(&arch_unw_init_frame_info);
	eval 'sub arch_unw_init_blocked {
	    my($info) = @_;
    	    eval q({  &memset( ($info->{regs}), 0, $sizeof{ ($info->{regs})});  ($info->{regs}->{eip}) =  ($info->{task}->{thread}->{eip});  ($info->{regs}->{xcs}) =  &__KERNEL_CS;  &__get_user( ($info->{regs}->{ebp}),  ($info->{task}->{thread}->{esp}));  ($info->{regs}->{esp}) =  ($info->{task}->{thread}->{esp});  ($info->{regs}->{xss}) =  &__KERNEL_DS;  ($info->{regs}->{xds}) =  &__USER_DS;  ($info->{regs}->{xes}) =  &__USER_DS; });
	}' unless defined(&arch_unw_init_blocked);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub arch_unw_user_mode {
	    my($info) = @_;
    	    eval q({ });
	}' unless defined(&arch_unw_user_mode);
    } else {
	eval 'sub UNW_PC {
	    my($frame) = @_;
    	    eval q((( &void)($frame), 0));
	}' unless defined(&UNW_PC);
	eval 'sub UNW_SP {
	    my($frame) = @_;
    	    eval q((( &void)($frame), 0));
	}' unless defined(&UNW_SP);
	eval 'sub arch_unw_user_mode {
	    my($info) = @_;
    	    eval q({ 0; });
	}' unless defined(&arch_unw_user_mode);
    }
}
1;
