require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X8664_DMA_MAPPING_H)) {
    eval 'sub _X8664_DMA_MAPPING_H {1;}' unless defined(&_X8664_DMA_MAPPING_H);
    require 'asm/scatterlist.ph';
    require 'asm/io.ph';
    require 'asm/swiotlb.ph';
    eval 'sub valid_dma_direction {
        my($dma_direction) = @_;
	    eval q({ (($dma_direction ==  &DMA_BIDIRECTIONAL) || ($dma_direction ==  &DMA_TO_DEVICE) || ($dma_direction ==  &DMA_FROM_DEVICE)); });
    }' unless defined(&valid_dma_direction);
    eval 'sub dma_mapping_error {
        my($dma_addr) = @_;
	    eval q({  &if ( ($dma_ops->{mapping_error}))  ($dma_ops->{mapping_error})($dma_addr); ($dma_addr ==  &bad_dma_address); });
    }' unless defined(&dma_mapping_error);
    eval 'sub dma_map_single {
        my($hwdev,$ptr,$size,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  ($dma_ops->{map_single})($hwdev, $ptr, $size, $direction); });
    }' unless defined(&dma_map_single);
    eval 'sub dma_unmap_single {
        my($dev,$addr,$size,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  ($dma_ops->{unmap_single})($dev, $addr, $size, $direction); });
    }' unless defined(&dma_unmap_single);
    eval 'sub dma_map_page {
        my($dev,$page,$offset,$size,$dir) = @_;
	    eval q( &dma_map_single(($dev),  &page_address($page)+($offset), ($size), ($dir)));
    }' unless defined(&dma_map_page);
    eval 'sub dma_unmap_page { &dma_unmap_single;}' unless defined(&dma_unmap_page);
    eval 'sub dma_sync_single_for_cpu {
        my($hwdev,$dma_handle,$size,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($dma_ops->{sync_single_for_cpu}))  ($dma_ops->{sync_single_for_cpu})($hwdev, $dma_handle, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_for_cpu);
    eval 'sub dma_sync_single_for_device {
        my($hwdev,$dma_handle,$size,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($dma_ops->{sync_single_for_device}))  ($dma_ops->{sync_single_for_device})($hwdev, $dma_handle, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_for_device);
    eval 'sub dma_sync_single_range_for_cpu {
        my($hwdev,$dma_handle,$offset,$size,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($dma_ops->{sync_single_range_for_cpu})) {  ($dma_ops->{sync_single_range_for_cpu})($hwdev, $dma_handle, $offset, $size, $direction); }  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_range_for_cpu);
    eval 'sub dma_sync_single_range_for_device {
        my($hwdev,$dma_handle,$offset,$size,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($dma_ops->{sync_single_range_for_device}))  ($dma_ops->{sync_single_range_for_device})($hwdev, $dma_handle, $offset, $size, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_single_range_for_device);
    eval 'sub dma_sync_sg_for_cpu {
        my($hwdev,$sg,$nelems,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($dma_ops->{sync_sg_for_cpu}))  ($dma_ops->{sync_sg_for_cpu})($hwdev, $sg, $nelems, $direction);  &flush_write_buffers(); });
    }' unless defined(&dma_sync_sg_for_cpu);
    eval 'sub dma_sync_sg_for_device {
        my($hwdev,$sg,$nelems,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  &if ( ($dma_ops->{sync_sg_for_device})) {  ($dma_ops->{sync_sg_for_device})($hwdev, $sg, $nelems, $direction); }  &flush_write_buffers(); });
    }' unless defined(&dma_sync_sg_for_device);
    eval 'sub dma_map_sg {
        my($hwdev,$sg,$nents,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  ($dma_ops->{map_sg})($hwdev, $sg, $nents, $direction); });
    }' unless defined(&dma_map_sg);
    eval 'sub dma_unmap_sg {
        my($hwdev,$sg,$nents,$direction) = @_;
	    eval q({  &BUG_ON(! &valid_dma_direction($direction));  ($dma_ops->{unmap_sg})($hwdev, $sg, $nents, $direction); });
    }' unless defined(&dma_unmap_sg);
    eval 'sub dma_is_consistent {
        my($h) = @_;
	    eval q(1);
    }' unless defined(&dma_is_consistent);
    eval 'sub dma_cache_sync {
        my($vaddr,$size,$dir) = @_;
	    eval q({  &flush_write_buffers(); });
    }' unless defined(&dma_cache_sync);
}
1;
