require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_X86_64_I387_H)) {
    eval 'sub __ASM_X86_64_I387_H {1;}' unless defined(&__ASM_X86_64_I387_H);
    require 'linux/sched.ph';
    require 'asm/processor.ph';
    require 'asm/sigcontext.ph';
    require 'asm/user.ph';
    require 'asm/thread_info.ph';
    require 'asm/uaccess.ph';
    eval 'sub unlazy_fpu {
        my($tsk) = @_;
	    eval q( &do {  &if ( &task_thread_info($tsk)-> &status &  &TS_USEDFPU)  &save_init_fpu($tsk); }  &while (0));
    }' unless defined(&unlazy_fpu);
    eval 'sub clear_fpu {
        my($tsk) = @_;
	    eval q( &do {  &if ( &task_thread_info($tsk)-> &status &  &TS_USEDFPU) {  &tolerant_fwait();  &task_thread_info($tsk)-> &status &= ~ &TS_USEDFPU;  &stts(); } }  &while (0));
    }' unless defined(&clear_fpu);
    eval 'sub get_fpu_mxcsr {
        my($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{mxcsr})));
    }' unless defined(&get_fpu_mxcsr);
    eval 'sub get_fpu_cwd {
        my($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{cwd})));
    }' unless defined(&get_fpu_cwd);
    eval 'sub get_fpu_fxsr_twd {
        my($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{twd})));
    }' unless defined(&get_fpu_fxsr_twd);
    eval 'sub get_fpu_swd {
        my($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{swd})));
    }' unless defined(&get_fpu_swd);
    eval 'sub set_fpu_cwd {
        my($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{cwd}) = ($val)));
    }' unless defined(&set_fpu_cwd);
    eval 'sub set_fpu_swd {
        my($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{swd}) = ($val)));
    }' unless defined(&set_fpu_swd);
    eval 'sub set_fpu_fxsr_twd {
        my($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{twd}) = ($val)));
    }' unless defined(&set_fpu_fxsr_twd);
    eval 'sub X87_FSW_ES {(1<< 7);}' unless defined(&X87_FSW_ES);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub restore_fpu_checking {
        my($fx) = @_;
	    eval q({ \'int\'  &err;  &asm  &volatile(\\"1:  rex64/fxrstor (%[fx])\\\\n\\\\t\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:  movl $-1,%[err]\\\\n\\" \\"    jmp  2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"   .align 8\\\\n\\" \\"   .quad  1b,3b\\\\n\\" \\".previous\\" : [ &err] \\"=r\\" ( &err)  &if ( &unlikely( &err))  &init_fpu( &current);  &err; } );
    }' unless defined(&restore_fpu_checking);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub save_i387_checking {
        my($fx) = @_;
	    eval q({ \'int\'  &err;  &asm  &volatile(\\"1:  rex64/fxsave (%[fx])\\\\n\\\\t\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:  movl $-1,%[err]\\\\n\\" \\"    jmp  2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"   .align 8\\\\n\\" \\"   .quad  1b,3b\\\\n\\" \\".previous\\" : [ &err] \\"=r\\" ( &err), \\"=m\\" (*$fx)  &if ( &unlikely( &err))  &__clear_user($fx, $sizeof{\'struct i387_fxsave_struct\'});  &err; } );
    }' unless defined(&save_i387_checking);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __fxsave_clear {
        my($tsk) = @_;
	    eval q({  &clear_fpu_state( ($tsk->{thread}->{i387}->{fxsave})); });
    }' unless defined(&__fxsave_clear);
    eval 'sub kernel_fpu_begin {
        my($void) = @_;
	    eval q({ \'struct thread_info\' * &me =  &current_thread_info();  &preempt_disable();  &if ( ($me->{status}) &  &TS_USEDFPU) {  &__fxsave_clear( ($me->{task}));  ($me->{status}) &= ~ &TS_USEDFPU; ; }  &clts(); });
    }' unless defined(&kernel_fpu_begin);
    eval 'sub kernel_fpu_end {
        my($void) = @_;
	    eval q({  &stts();  &preempt_enable(); });
    }' unless defined(&kernel_fpu_end);
    eval 'sub save_init_fpu {
        my($tsk) = @_;
	    eval q({  &__fxsave_clear($tsk);  &task_thread_info($tsk)-> &status &= ~ &TS_USEDFPU;  &stts(); });
    }' unless defined(&save_init_fpu);
}
1;
