require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IRQFLAGS_H)) {
    eval 'sub _ASM_IRQFLAGS_H {1;}' unless defined(&_ASM_IRQFLAGS_H);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub raw_local_save_flags {
	    my($flags) = @_;
    	    eval q( &do { ($flags) =  &__raw_local_save_flags(); }  &while (0));
	}' unless defined(&raw_local_save_flags);
	eval 'sub raw_local_irq_restore {
	    my($flags) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&raw_local_irq_restore);
	if(defined(&CONFIG_X86_VSMP)) {
	    eval 'sub raw_local_irq_enable {
	        my($void) = @_;
    		eval q({ my $flags =  &__raw_local_save_flags();  &raw_local_irq_restore(( $flags | (1<< 9)) & ~(1<< 18)); });
	    }' unless defined(&raw_local_irq_enable);
	    eval 'sub raw_irqs_disabled_flags {
	        my($flags) = @_;
    		eval q({ !($flags & (1<<9)) || ($flags & (1<< 18)); });
	    }' unless defined(&raw_irqs_disabled_flags);
	} else {
	    eval 'sub raw_local_irq_disable {
	        my($void) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&raw_local_irq_disable);
	    eval 'sub raw_local_irq_enable {
	        my($void) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&raw_local_irq_enable);
	    eval 'sub raw_irqs_disabled_flags {
	        my($flags) = @_;
    		eval q({ !($flags & (1<< 9)); });
	    }' unless defined(&raw_irqs_disabled_flags);
	}
	eval 'sub raw_local_irq_save {
	    my($flags) = @_;
    	    eval q( &do { ($flags) =  &__raw_local_irq_save(); }  &while (0));
	}' unless defined(&raw_local_irq_save);
	eval 'sub raw_irqs_disabled {
	    my($void) = @_;
    	    eval q({ my $flags =  &__raw_local_save_flags();  &raw_irqs_disabled_flags( $flags); });
	}' unless defined(&raw_irqs_disabled);
    } else {
	if(defined(&CONFIG_TRACE_IRQFLAGS)) {
	    eval 'sub TRACE_IRQS_ON { &call  &trace_hardirqs_on_thunk;}' unless defined(&TRACE_IRQS_ON);
	    eval 'sub TRACE_IRQS_OFF { &call  &trace_hardirqs_off_thunk;}' unless defined(&TRACE_IRQS_OFF);
	} else {
	    eval 'sub TRACE_IRQS_ON {1;}' unless defined(&TRACE_IRQS_ON);
	    eval 'sub TRACE_IRQS_OFF {1;}' unless defined(&TRACE_IRQS_OFF);
	}
    }
}
1;
