require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_PGALLOC_H)) {
    eval 'sub _X86_64_PGALLOC_H {1;}' unless defined(&_X86_64_PGALLOC_H);
    require 'asm/fixmap.ph';
    require 'asm/pda.ph';
    require 'linux/threads.ph';
    require 'linux/mm.ph';
    eval 'sub pmd_populate_kernel {
        my($mm, $pmd, $pte) = @_;
	    eval q( &set_pmd($pmd,  &__pmd( &_PAGE_TABLE |  &__pa($pte))));
    }' unless defined(&pmd_populate_kernel);
    eval 'sub pud_populate {
        my($mm, $pud, $pmd) = @_;
	    eval q( &set_pud($pud,  &__pud( &_PAGE_TABLE |  &__pa($pmd))));
    }' unless defined(&pud_populate);
    eval 'sub pgd_populate {
        my($mm, $pgd, $pud) = @_;
	    eval q( &set_pgd($pgd,  &__pgd( &_PAGE_TABLE |  &__pa($pud))));
    }' unless defined(&pgd_populate);
    eval 'sub pmd_populate {
        my($mm,$pmd,$pte) = @_;
	    eval q({  &set_pmd($pmd,  &__pmd( &_PAGE_TABLE | ( &page_to_pfn($pte) <<  &PAGE_SHIFT))); });
    }' unless defined(&pmd_populate);
    eval 'sub pmd_t {
        eval q(* &get_pmd( &void) { ( &pmd_t *) &get_zeroed_page( &GFP_KERNEL); });
    }' unless defined(&pmd_t);
    eval 'sub pmd_free {
        my($pmd) = @_;
	    eval q({  &BUG_ON($pmd & ( &PAGE_SIZE-1));  &free_page($pmd); });
    }' unless defined(&pmd_free);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one (\'struct mm_struct\' * &mm, my $addr) { ( &pmd_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pmd_t);
    eval 'sub pud_t {
        eval q(* &pud_alloc_one(\'struct mm_struct\' * &mm, my $addr) { ( &pud_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pud_t);
    eval 'sub pud_free {
        my($pud) = @_;
	    eval q({  &BUG_ON($pud & ( &PAGE_SIZE-1));  &free_page($pud); });
    }' unless defined(&pud_free);
    eval 'sub pgd_list_add {
        my($pgd) = @_;
	    eval q({ \'struct page\' * &page =  &virt_to_page($pgd);  &spin_lock( &pgd_lock);  ($page->{index}) = ( &pgoff_t) &pgd_list;  &if ( &pgd_list)  ($pgd_list->{private}) =  ($page->{index});  &pgd_list =  &page;  ($page->{private}) =  &pgd_list;  &spin_unlock( &pgd_lock); });
    }' unless defined(&pgd_list_add);
    eval 'sub pgd_list_del {
        my($pgd) = @_;
	    eval q({ \'struct page\' * &next, ** &pprev, * &page =  &virt_to_page($pgd);  &spin_lock( &pgd_lock);  &next =  ($page->{index});  &pprev =  ($page->{private}); * &pprev =  &next;  &if ( &next)  ($next->{private}) =  &pprev;  &spin_unlock( &pgd_lock); });
    }' unless defined(&pgd_list_del);
    eval 'sub pgd_t {
        eval q(* &pgd_alloc(\'struct mm_struct\' * &mm) { \'unsigned boundary\';  &pgd_t * &pgd = ( &pgd_t *) &__get_free_page( &GFP_KERNEL| &__GFP_REPEAT);  &if (! &pgd)  &NULL;  &pgd_list_add( &pgd);  &boundary =  &pgd_index( &__PAGE_OFFSET);  &memset( &pgd, 0,  &boundary * $sizeof{ &pgd_t});  &memcpy( &pgd +  &boundary,  &init_level4_pgt +  &boundary, ( &PTRS_PER_PGD -  &boundary) * $sizeof{ &pgd_t});  &pgd; });
    }' unless defined(&pgd_t);
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q({  &BUG_ON($pgd & ( &PAGE_SIZE-1));  &pgd_list_del($pgd);  &free_page($pgd); });
    }' unless defined(&pgd_free);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one_kernel(\'struct mm_struct\' * &mm, my $address) { ( &pte_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pte_t);
    eval 'sub page {
        eval q(* &pte_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &void * &p = ( &void *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT);  &if (! &p)  &NULL;  &virt_to_page( &p); });
    }' unless defined(&page);
    eval 'sub pte_free {
        my($pte) = @_;
	    eval q({  &__free_page($pte); } );
    }' unless defined(&pte_free);
    eval 'sub __pte_free_tlb {
        my($tlb,$pte) = @_;
	    eval q( &tlb_remove_page(($tlb),($pte)));
    }' unless defined(&__pte_free_tlb);
    eval 'sub __pmd_free_tlb {
        my($tlb,$x) = @_;
	    eval q( &tlb_remove_page(($tlb), &virt_to_page($x)));
    }' unless defined(&__pmd_free_tlb);
    eval 'sub __pud_free_tlb {
        my($tlb,$x) = @_;
	    eval q( &tlb_remove_page(($tlb), &virt_to_page($x)));
    }' unless defined(&__pud_free_tlb);
}
1;
