require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_64_UNWIND_H)) {
    eval 'sub _ASM_X86_64_UNWIND_H {1;}' unless defined(&_ASM_X86_64_UNWIND_H);
    if(defined(&CONFIG_STACK_UNWIND)) {
	require 'linux/sched.ph';
	require 'asm/ptrace.ph';
	require 'asm/uaccess.ph';
	require 'asm/vsyscall.ph';
	eval 'sub UNW_PC {
	    my($frame) = @_;
    	    eval q(($frame)-> ($regs->{rip}));
	}' unless defined(&UNW_PC);
	eval 'sub UNW_SP {
	    my($frame) = @_;
    	    eval q(($frame)-> ($regs->{rsp}));
	}' unless defined(&UNW_SP);
	if(defined(&CONFIG_FRAME_POINTER)) {
	    eval 'sub UNW_FP {
	        my($frame) = @_;
    		eval q(($frame)-> ($regs->{rbp}));
	    }' unless defined(&UNW_FP);
	    eval 'sub FRAME_RETADDR_OFFSET {8;}' unless defined(&FRAME_RETADDR_OFFSET);
	    eval 'sub FRAME_LINK_OFFSET {0;}' unless defined(&FRAME_LINK_OFFSET);
	    eval 'sub STACK_BOTTOM {
	        my($tsk) = @_;
    		eval q(((($tsk)-> ($thread->{rsp0}) - 1) & ~( &THREAD_SIZE - 1)));
	    }' unless defined(&STACK_BOTTOM);
	    eval 'sub STACK_TOP {
	        my($tsk) = @_;
    		eval q((($tsk)-> ($thread->{rsp0})));
	    }' unless defined(&STACK_TOP);
	}
	eval 'sub STACK_LIMIT {
	    my($ptr) = @_;
    	    eval q(((($ptr) - 1) & ~( &THREAD_SIZE - 1)));
	}' unless defined(&STACK_LIMIT);
	eval 'sub UNW_REGISTER_INFO { &PTREGS_INFO( &rax),  &PTREGS_INFO( &rdx),  &PTREGS_INFO( &rcx),  &PTREGS_INFO( &rbx),  &PTREGS_INFO( &rsi),  &PTREGS_INFO( &rdi),  &PTREGS_INFO( &rbp),  &PTREGS_INFO( &rsp),  &PTREGS_INFO( &r8),  &PTREGS_INFO( &r9),  &PTREGS_INFO( &r10),  &PTREGS_INFO( &r11),  &PTREGS_INFO( &r12),  &PTREGS_INFO( &r13),  &PTREGS_INFO( &r14),  &PTREGS_INFO( &r15),  &PTREGS_INFO( &rip);}' unless defined(&UNW_REGISTER_INFO);
	eval 'sub arch_unw_init_frame_info {
	    my($info,$regs) = @_;
    	    eval q({  ($info->{regs}) = *$regs; });
	}' unless defined(&arch_unw_init_frame_info);
	eval 'sub arch_unw_init_blocked {
	    my($info) = @_;
    	    eval q({  &const \'char\'  $thread_return[];  &memset( ($info->{regs}), 0, $sizeof{ ($info->{regs})});  ($info->{regs}->{rip}) =  &thread_return;  ($info->{regs}->{cs}) =  &__KERNEL_CS;  &__get_user( ($info->{regs}->{rbp}),  ($info->{task}->{thread}->{rsp}));  ($info->{regs}->{rsp}) =  ($info->{task}->{thread}->{rsp});  ($info->{regs}->{ss}) =  &__KERNEL_DS; });
	}' unless defined(&arch_unw_init_blocked);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub arch_unw_user_mode {
	    my($info) = @_;
    	    eval q({ });
	}' unless defined(&arch_unw_user_mode);
    } else {
	eval 'sub UNW_PC {
	    my($frame) = @_;
    	    eval q((( &void)($frame), 0));
	}' unless defined(&UNW_PC);
	eval 'sub UNW_SP {
	    my($frame) = @_;
    	    eval q((( &void)($frame), 0));
	}' unless defined(&UNW_SP);
	eval 'sub arch_unw_user_mode {
	    my($info) = @_;
    	    eval q({ 0; });
	}' unless defined(&arch_unw_user_mode);
    }
}
1;
