require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_BOOTMEM_H)) {
    eval 'sub _LINUX_BOOTMEM_H {1;}' unless defined(&_LINUX_BOOTMEM_H);
    require 'asm/pgtable.ph';
    require 'asm/dma.ph';
    require 'linux/cache.ph';
    require 'linux/init.ph';
    require 'linux/mmzone.ph';
    if(defined(&CONFIG_CRASH_DUMP)) {
    }
    unless(defined(&CONFIG_HAVE_ARCH_BOOTMEM_NODE)) {
	eval 'sub alloc_bootmem {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem(($x),  &SMP_CACHE_BYTES,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem);
	eval 'sub alloc_bootmem_low {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem_low(($x),  &SMP_CACHE_BYTES, 0));
	}' unless defined(&alloc_bootmem_low);
	eval 'sub alloc_bootmem_pages {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem(($x),  &PAGE_SIZE,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem_pages);
	eval 'sub alloc_bootmem_low_pages {
	    my($x) = @_;
    	    eval q( &__alloc_bootmem_low(($x),  &PAGE_SIZE, 0));
	}' unless defined(&alloc_bootmem_low_pages);
    }
    unless(defined(&CONFIG_HAVE_ARCH_BOOTMEM_NODE)) {
	eval 'sub alloc_bootmem_node {
	    my($pgdat, $x) = @_;
    	    eval q( &__alloc_bootmem_node(($pgdat), ($x),  &SMP_CACHE_BYTES,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem_node);
	eval 'sub alloc_bootmem_pages_node {
	    my($pgdat, $x) = @_;
    	    eval q( &__alloc_bootmem_node(($pgdat), ($x),  &PAGE_SIZE,  &__pa( &MAX_DMA_ADDRESS)));
	}' unless defined(&alloc_bootmem_pages_node);
	eval 'sub alloc_bootmem_low_pages_node {
	    my($pgdat, $x) = @_;
    	    eval q( &__alloc_bootmem_low_node(($pgdat), ($x),  &PAGE_SIZE, 0));
	}' unless defined(&alloc_bootmem_low_pages_node);
    }
    if(defined(&CONFIG_HAVE_ARCH_ALLOC_REMAP)) {
    } else {
	eval 'sub void {
	    eval q(* &alloc_remap(\'int\'  &nid, my $size) {  &NULL; });
	}' unless defined(&void);
    }
    eval 'sub HASH_HIGHMEM {0x1;}' unless defined(&HASH_HIGHMEM);
    eval 'sub HASH_EARLY {0x2;}' unless defined(&HASH_EARLY);
    if(defined( &CONFIG_NUMA)  && defined( &CONFIG_IA64)) {
	eval 'sub HASHDIST_DEFAULT {1;}' unless defined(&HASHDIST_DEFAULT);
    } else {
	eval 'sub HASHDIST_DEFAULT {0;}' unless defined(&HASHDIST_DEFAULT);
    }
}
1;
