require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__IDR_H__)) {
    eval 'sub __IDR_H__ {1;}' unless defined(&__IDR_H__);
    require 'linux/types.ph';
    require 'linux/bitops.ph';
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) == 32) {
	eval 'sub IDR_BITS {5;}' unless defined(&IDR_BITS);
	eval 'sub IDR_FULL {0xffffffff;}' unless defined(&IDR_FULL);
	eval 'sub TOP_LEVEL_FULL {( &IDR_FULL >> 30);}' unless defined(&TOP_LEVEL_FULL);
    }
 elsif((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) == 64) {
	eval 'sub IDR_BITS {6;}' unless defined(&IDR_BITS);
	eval 'sub IDR_FULL {0xffffffffffffffff;}' unless defined(&IDR_FULL);
	eval 'sub TOP_LEVEL_FULL {( &IDR_FULL >> 62);}' unless defined(&TOP_LEVEL_FULL);
    } else {
	die("BITS_PER_LONG is not 32 or 64");
    }
    eval 'sub IDR_SIZE {(1<<  &IDR_BITS);}' unless defined(&IDR_SIZE);
    eval 'sub IDR_MASK {((1<<  &IDR_BITS)-1);}' unless defined(&IDR_MASK);
    eval 'sub MAX_ID_SHIFT {($sizeof{\'int\'}*8- 1);}' unless defined(&MAX_ID_SHIFT);
    eval 'sub MAX_ID_BIT {(1 <<  &MAX_ID_SHIFT);}' unless defined(&MAX_ID_BIT);
    eval 'sub MAX_ID_MASK {( &MAX_ID_BIT - 1);}' unless defined(&MAX_ID_MASK);
    eval 'sub MAX_LEVEL {( &MAX_ID_SHIFT +  &IDR_BITS - 1) /  &IDR_BITS;}' unless defined(&MAX_LEVEL);
    eval 'sub IDR_FREE_MAX { &MAX_LEVEL +  &MAX_LEVEL;}' unless defined(&IDR_FREE_MAX);
    eval 'sub IDR_INIT {
        my($name) = @_;
	    eval q({ . &top =  &NULL, . &id_free =  &NULL, . &layers = 0, . &id_free_cnt = 0, . &lock =  &__SPIN_LOCK_UNLOCKED( ($name->{lock})), });
    }' unless defined(&IDR_INIT);
    eval 'sub DEFINE_IDR {
        my($name) = @_;
	    eval q(\'struct idr\' $name =  &IDR_INIT($name));
    }' unless defined(&DEFINE_IDR);
}
1;
