require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_IPMI_H)) {
    eval 'sub __LINUX_IPMI_H {1;}' unless defined(&__LINUX_IPMI_H);
    require 'linux/ipmi_msgdefs.ph';
    require 'linux/compiler.ph';
    eval 'sub IPMI_MAX_ADDR_SIZE {32;}' unless defined(&IPMI_MAX_ADDR_SIZE);
    eval 'sub IPMI_SYSTEM_INTERFACE_ADDR_TYPE {0xc;}' unless defined(&IPMI_SYSTEM_INTERFACE_ADDR_TYPE);
    eval 'sub IPMI_IPMB_ADDR_TYPE {0x1;}' unless defined(&IPMI_IPMB_ADDR_TYPE);
    eval 'sub IPMI_IPMB_BROADCAST_ADDR_TYPE {0x41;}' unless defined(&IPMI_IPMB_BROADCAST_ADDR_TYPE);
    eval 'sub IPMI_LAN_ADDR_TYPE {0x4;}' unless defined(&IPMI_LAN_ADDR_TYPE);
    eval 'sub IPMI_BMC_CHANNEL {0xf;}' unless defined(&IPMI_BMC_CHANNEL);
    eval 'sub IPMI_NUM_CHANNELS {0x10;}' unless defined(&IPMI_NUM_CHANNELS);
    eval 'sub IPMI_INVALID_CMD_COMPLETION_CODE {0xc1;}' unless defined(&IPMI_INVALID_CMD_COMPLETION_CODE);
    eval 'sub IPMI_TIMEOUT_COMPLETION_CODE {0xc3;}' unless defined(&IPMI_TIMEOUT_COMPLETION_CODE);
    eval 'sub IPMI_UNKNOWN_ERR_COMPLETION_CODE {0xff;}' unless defined(&IPMI_UNKNOWN_ERR_COMPLETION_CODE);
    eval 'sub IPMI_RESPONSE_RECV_TYPE {1;}' unless defined(&IPMI_RESPONSE_RECV_TYPE);
    eval 'sub IPMI_ASYNC_EVENT_RECV_TYPE {2;}' unless defined(&IPMI_ASYNC_EVENT_RECV_TYPE);
    eval 'sub IPMI_CMD_RECV_TYPE {3;}' unless defined(&IPMI_CMD_RECV_TYPE);
    eval 'sub IPMI_RESPONSE_RESPONSE_TYPE {4;}' unless defined(&IPMI_RESPONSE_RESPONSE_TYPE);
    if(defined(&__KERNEL__)) {
	require 'linux/list.ph';
	require 'linux/module.ph';
	require 'linux/device.ph';
	require 'linux/proc_fs.ph';
    }
    eval 'sub IPMI_IOC_MAGIC {ord(\'i\');}' unless defined(&IPMI_IOC_MAGIC);
    eval 'sub IPMICTL_SEND_COMMAND { &_IOR( &IPMI_IOC_MAGIC, 13, \'struct ipmi_req\');}' unless defined(&IPMICTL_SEND_COMMAND);
    eval 'sub IPMICTL_SEND_COMMAND_SETTIME { &_IOR( &IPMI_IOC_MAGIC, 21, \'struct ipmi_req_settime\');}' unless defined(&IPMICTL_SEND_COMMAND_SETTIME);
    eval 'sub IPMICTL_RECEIVE_MSG { &_IOWR( &IPMI_IOC_MAGIC, 12, \'struct ipmi_recv\');}' unless defined(&IPMICTL_RECEIVE_MSG);
    eval 'sub IPMICTL_RECEIVE_MSG_TRUNC { &_IOWR( &IPMI_IOC_MAGIC, 11, \'struct ipmi_recv\');}' unless defined(&IPMICTL_RECEIVE_MSG_TRUNC);
    eval 'sub IPMICTL_REGISTER_FOR_CMD { &_IOR( &IPMI_IOC_MAGIC, 14, \'struct ipmi_cmdspec\');}' unless defined(&IPMICTL_REGISTER_FOR_CMD);
    eval 'sub IPMICTL_UNREGISTER_FOR_CMD { &_IOR( &IPMI_IOC_MAGIC, 15, \'struct ipmi_cmdspec\');}' unless defined(&IPMICTL_UNREGISTER_FOR_CMD);
    eval 'sub IPMICTL_SET_GETS_EVENTS_CMD { &_IOR( &IPMI_IOC_MAGIC, 16, \'int\');}' unless defined(&IPMICTL_SET_GETS_EVENTS_CMD);
    eval 'sub IPMICTL_SET_MY_CHANNEL_ADDRESS_CMD { &_IOR( &IPMI_IOC_MAGIC, 24, \'struct ipmi_channel_lun_address_set\');}' unless defined(&IPMICTL_SET_MY_CHANNEL_ADDRESS_CMD);
    eval 'sub IPMICTL_GET_MY_CHANNEL_ADDRESS_CMD { &_IOR( &IPMI_IOC_MAGIC, 25, \'struct ipmi_channel_lun_address_set\');}' unless defined(&IPMICTL_GET_MY_CHANNEL_ADDRESS_CMD);
    eval 'sub IPMICTL_SET_MY_CHANNEL_LUN_CMD { &_IOR( &IPMI_IOC_MAGIC, 26, \'struct ipmi_channel_lun_address_set\');}' unless defined(&IPMICTL_SET_MY_CHANNEL_LUN_CMD);
    eval 'sub IPMICTL_GET_MY_CHANNEL_LUN_CMD { &_IOR( &IPMI_IOC_MAGIC, 27, \'struct ipmi_channel_lun_address_set\');}' unless defined(&IPMICTL_GET_MY_CHANNEL_LUN_CMD);
    eval 'sub IPMICTL_SET_MY_ADDRESS_CMD { &_IOR( &IPMI_IOC_MAGIC, 17, \'unsigned int\');}' unless defined(&IPMICTL_SET_MY_ADDRESS_CMD);
    eval 'sub IPMICTL_GET_MY_ADDRESS_CMD { &_IOR( &IPMI_IOC_MAGIC, 18, \'unsigned int\');}' unless defined(&IPMICTL_GET_MY_ADDRESS_CMD);
    eval 'sub IPMICTL_SET_MY_LUN_CMD { &_IOR( &IPMI_IOC_MAGIC, 19, \'unsigned int\');}' unless defined(&IPMICTL_SET_MY_LUN_CMD);
    eval 'sub IPMICTL_GET_MY_LUN_CMD { &_IOR( &IPMI_IOC_MAGIC, 20, \'unsigned int\');}' unless defined(&IPMICTL_GET_MY_LUN_CMD);
    eval 'sub IPMICTL_SET_TIMING_PARMS_CMD { &_IOR( &IPMI_IOC_MAGIC, 22, \'struct ipmi_timing_parms\');}' unless defined(&IPMICTL_SET_TIMING_PARMS_CMD);
    eval 'sub IPMICTL_GET_TIMING_PARMS_CMD { &_IOR( &IPMI_IOC_MAGIC, 23, \'struct ipmi_timing_parms\');}' unless defined(&IPMICTL_GET_TIMING_PARMS_CMD);
}
1;
