require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_LIBATA_H__)) {
    eval 'sub __LINUX_LIBATA_H__ {1;}' unless defined(&__LINUX_LIBATA_H__);
    require 'linux/delay.ph';
    require 'linux/interrupt.ph';
    require 'linux/pci.ph';
    require 'linux/dma-mapping.ph';
    require 'asm/scatterlist.ph';
    require 'asm/io.ph';
    require 'linux/ata.ph';
    require 'linux/workqueue.ph';
    require 'scsi/scsi_host.ph';
    undef(&ATA_DEBUG) if defined(&ATA_DEBUG);
    undef(&ATA_VERBOSE_DEBUG) if defined(&ATA_VERBOSE_DEBUG);
    undef(&ATA_IRQ_TRAP) if defined(&ATA_IRQ_TRAP);
    undef(&ATA_NDEBUG) if defined(&ATA_NDEBUG);
    undef(&ATA_ENABLE_PATA) if defined(&ATA_ENABLE_PATA);
    if(defined(&ATA_DEBUG)) {
	eval 'sub DPRINTK {( &fmt,  &args...)  &printk( &KERN_ERR "%s: "  &fmt,  &__FUNCTION__,   &args);}' unless defined(&DPRINTK);
	if(defined(&ATA_VERBOSE_DEBUG)) {
	    eval 'sub VPRINTK {( &fmt,  &args...)  &printk( &KERN_ERR "%s: "  &fmt,  &__FUNCTION__,   &args);}' unless defined(&VPRINTK);
	} else {
	    eval 'sub VPRINTK {( &fmt,  &args...);}' unless defined(&VPRINTK);
	}
    } else {
	eval 'sub DPRINTK {( &fmt,  &args...);}' unless defined(&DPRINTK);
	eval 'sub VPRINTK {( &fmt,  &args...);}' unless defined(&VPRINTK);
    }
    eval 'sub BPRINTK {( &fmt,  &args...)  &if ( ($ap->{flags}) &  &ATA_FLAG_DEBUGMSG)  &printk( &KERN_ERR "%s: "  &fmt,  &__FUNCTION__,   &args);}' unless defined(&BPRINTK);
    eval 'sub HAVE_LIBATA_MSG {1;}' unless defined(&HAVE_LIBATA_MSG);
    eval("sub ATA_MSG_DRV () { 0x0001; }") unless defined(&ATA_MSG_DRV);
    eval("sub ATA_MSG_INFO () { 0x0002; }") unless defined(&ATA_MSG_INFO);
    eval("sub ATA_MSG_PROBE () { 0x0004; }") unless defined(&ATA_MSG_PROBE);
    eval("sub ATA_MSG_WARN () { 0x0008; }") unless defined(&ATA_MSG_WARN);
    eval("sub ATA_MSG_MALLOC () { 0x0010; }") unless defined(&ATA_MSG_MALLOC);
    eval("sub ATA_MSG_CTL () { 0x0020; }") unless defined(&ATA_MSG_CTL);
    eval("sub ATA_MSG_INTR () { 0x0040; }") unless defined(&ATA_MSG_INTR);
    eval("sub ATA_MSG_ERR () { 0x0080; }") unless defined(&ATA_MSG_ERR);
    eval 'sub ata_msg_drv {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_DRV));
    }' unless defined(&ata_msg_drv);
    eval 'sub ata_msg_info {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_INFO));
    }' unless defined(&ata_msg_info);
    eval 'sub ata_msg_probe {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_PROBE));
    }' unless defined(&ata_msg_probe);
    eval 'sub ata_msg_warn {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_WARN));
    }' unless defined(&ata_msg_warn);
    eval 'sub ata_msg_malloc {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_MALLOC));
    }' unless defined(&ata_msg_malloc);
    eval 'sub ata_msg_ctl {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_CTL));
    }' unless defined(&ata_msg_ctl);
    eval 'sub ata_msg_intr {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_INTR));
    }' unless defined(&ata_msg_intr);
    eval 'sub ata_msg_err {
        my($p) = @_;
	    eval q((($p)-> &msg_enable &  &ATA_MSG_ERR));
    }' unless defined(&ata_msg_err);
    eval 'sub ata_msg_init {
        my($dval,$default_msg_enable_bits) = @_;
	    eval q({  &if ($dval < 0|| $dval >= ($sizeof{ &u32} * 8)) $default_msg_enable_bits;  &if (!$dval) 0; (1<< $dval) - 1; });
    }' unless defined(&ata_msg_init);
    eval 'sub ATA_TAG_POISON {0xfafbfcfd;}' unless defined(&ATA_TAG_POISON);
    eval("sub LIBATA_MAX_PRD () { ATA_MAX_PRD/2; }") unless defined(&LIBATA_MAX_PRD);
    eval("sub ATA_MAX_PORTS () { 8; }") unless defined(&ATA_MAX_PORTS);
    eval("sub ATA_DEF_QUEUE () { 1; }") unless defined(&ATA_DEF_QUEUE);
    eval("sub ATA_MAX_QUEUE () { 32; }") unless defined(&ATA_MAX_QUEUE);
    eval("sub ATA_TAG_INTERNAL () { ATA_MAX_QUEUE-1; }") unless defined(&ATA_TAG_INTERNAL);
    eval("sub ATA_MAX_SECTORS () { 200; }") unless defined(&ATA_MAX_SECTORS);
    eval("sub ATA_MAX_SECTORS_LBA48 () { 65535; }") unless defined(&ATA_MAX_SECTORS_LBA48);
    eval("sub ATA_MAX_BUS () { 2; }") unless defined(&ATA_MAX_BUS);
    eval("sub ATA_DEF_BUSY_WAIT () { 10000; }") unless defined(&ATA_DEF_BUSY_WAIT);
    eval("sub ATA_SHORT_PAUSE () { (HZ>>6)+1; }") unless defined(&ATA_SHORT_PAUSE);
    eval("sub ATA_SHT_EMULATED () { 1; }") unless defined(&ATA_SHT_EMULATED);
    eval("sub ATA_SHT_CMD_PER_LUN () { 1; }") unless defined(&ATA_SHT_CMD_PER_LUN);
    eval("sub ATA_SHT_THIS_ID () { -1; }") unless defined(&ATA_SHT_THIS_ID);
    eval("sub ATA_SHT_USE_CLUSTERING () { 1; }") unless defined(&ATA_SHT_USE_CLUSTERING);
    eval("sub ATA_DFLAG_LBA () { (1<<0); }") unless defined(&ATA_DFLAG_LBA);
    eval("sub ATA_DFLAG_LBA48 () { (1<<1); }") unless defined(&ATA_DFLAG_LBA48);
    eval("sub ATA_DFLAG_CDB_INTR () { (1<<2); }") unless defined(&ATA_DFLAG_CDB_INTR);
    eval("sub ATA_DFLAG_NCQ () { (1<<3); }") unless defined(&ATA_DFLAG_NCQ);
    eval("sub ATA_DFLAG_CFG_MASK () { (1<<8)-1; }") unless defined(&ATA_DFLAG_CFG_MASK);
    eval("sub ATA_DFLAG_PIO () { (1<<8); }") unless defined(&ATA_DFLAG_PIO);
    eval("sub ATA_DFLAG_SUSPENDED () { (1<<9); }") unless defined(&ATA_DFLAG_SUSPENDED);
    eval("sub ATA_DFLAG_INIT_MASK () { (1<<16)-1; }") unless defined(&ATA_DFLAG_INIT_MASK);
    eval("sub ATA_DFLAG_DETACH () { (1<<16); }") unless defined(&ATA_DFLAG_DETACH);
    eval("sub ATA_DFLAG_DETACHED () { (1<<17); }") unless defined(&ATA_DFLAG_DETACHED);
    eval("sub ATA_DEV_UNKNOWN () { 0; }") unless defined(&ATA_DEV_UNKNOWN);
    eval("sub ATA_DEV_ATA () { 1; }") unless defined(&ATA_DEV_ATA);
    eval("sub ATA_DEV_ATA_UNSUP () { 2; }") unless defined(&ATA_DEV_ATA_UNSUP);
    eval("sub ATA_DEV_ATAPI () { 3; }") unless defined(&ATA_DEV_ATAPI);
    eval("sub ATA_DEV_ATAPI_UNSUP () { 4; }") unless defined(&ATA_DEV_ATAPI_UNSUP);
    eval("sub ATA_DEV_NONE () { 5; }") unless defined(&ATA_DEV_NONE);
    eval("sub ATA_FLAG_SLAVE_POSS () { (1<<0); }") unless defined(&ATA_FLAG_SLAVE_POSS);
    eval("sub ATA_FLAG_SATA () { (1<<1); }") unless defined(&ATA_FLAG_SATA);
    eval("sub ATA_FLAG_NO_LEGACY () { (1<<2); }") unless defined(&ATA_FLAG_NO_LEGACY);
    eval("sub ATA_FLAG_MMIO () { (1<<3); }") unless defined(&ATA_FLAG_MMIO);
    eval("sub ATA_FLAG_SRST () { (1<<4); }") unless defined(&ATA_FLAG_SRST);
    eval("sub ATA_FLAG_SATA_RESET () { (1<<5); }") unless defined(&ATA_FLAG_SATA_RESET);
    eval("sub ATA_FLAG_NO_ATAPI () { (1<<6); }") unless defined(&ATA_FLAG_NO_ATAPI);
    eval("sub ATA_FLAG_PIO_DMA () { (1<<7); }") unless defined(&ATA_FLAG_PIO_DMA);
    eval("sub ATA_FLAG_PIO_LBA48 () { (1<<8); }") unless defined(&ATA_FLAG_PIO_LBA48);
    eval("sub ATA_FLAG_PIO_POLLING () { (1<<9); }") unless defined(&ATA_FLAG_PIO_POLLING);
    eval("sub ATA_FLAG_NCQ () { (1<<10); }") unless defined(&ATA_FLAG_NCQ);
    eval("sub ATA_FLAG_HRST_TO_RESUME () { (1<<11); }") unless defined(&ATA_FLAG_HRST_TO_RESUME);
    eval("sub ATA_FLAG_SKIP_D2H_BSY () { (1<<12); }") unless defined(&ATA_FLAG_SKIP_D2H_BSY);
    eval("sub ATA_FLAG_DEBUGMSG () { (1<<13); }") unless defined(&ATA_FLAG_DEBUGMSG);
    eval("sub ATA_FLAG_DISABLED () { (1<<23); }") unless defined(&ATA_FLAG_DISABLED);
    eval("sub ATA_PFLAG_EH_PENDING () { (1<<0); }") unless defined(&ATA_PFLAG_EH_PENDING);
    eval("sub ATA_PFLAG_EH_IN_PROGRESS () { (1<<1); }") unless defined(&ATA_PFLAG_EH_IN_PROGRESS);
    eval("sub ATA_PFLAG_FROZEN () { (1<<2); }") unless defined(&ATA_PFLAG_FROZEN);
    eval("sub ATA_PFLAG_RECOVERED () { (1<<3); }") unless defined(&ATA_PFLAG_RECOVERED);
    eval("sub ATA_PFLAG_LOADING () { (1<<4); }") unless defined(&ATA_PFLAG_LOADING);
    eval("sub ATA_PFLAG_UNLOADING () { (1<<5); }") unless defined(&ATA_PFLAG_UNLOADING);
    eval("sub ATA_PFLAG_SCSI_HOTPLUG () { (1<<6); }") unless defined(&ATA_PFLAG_SCSI_HOTPLUG);
    eval("sub ATA_PFLAG_FLUSH_PORT_TASK () { (1<<16); }") unless defined(&ATA_PFLAG_FLUSH_PORT_TASK);
    eval("sub ATA_PFLAG_SUSPENDED () { (1<<17); }") unless defined(&ATA_PFLAG_SUSPENDED);
    eval("sub ATA_PFLAG_PM_PENDING () { (1<<18); }") unless defined(&ATA_PFLAG_PM_PENDING);
    eval("sub ATA_QCFLAG_ACTIVE () { (1<<0); }") unless defined(&ATA_QCFLAG_ACTIVE);
    eval("sub ATA_QCFLAG_SG () { (1<<1); }") unless defined(&ATA_QCFLAG_SG);
    eval("sub ATA_QCFLAG_SINGLE () { (1<<2); }") unless defined(&ATA_QCFLAG_SINGLE);
    eval("sub ATA_QCFLAG_DMAMAP () { ATA_QCFLAG_SG|ATA_QCFLAG_SINGLE; }") unless defined(&ATA_QCFLAG_DMAMAP);
    eval("sub ATA_QCFLAG_IO () { (1<<3); }") unless defined(&ATA_QCFLAG_IO);
    eval("sub ATA_QCFLAG_RESULT_TF () { (1<<4); }") unless defined(&ATA_QCFLAG_RESULT_TF);
    eval("sub ATA_QCFLAG_FAILED () { (1<<16); }") unless defined(&ATA_QCFLAG_FAILED);
    eval("sub ATA_QCFLAG_SENSE_VALID () { (1<<17); }") unless defined(&ATA_QCFLAG_SENSE_VALID);
    eval("sub ATA_QCFLAG_EH_SCHEDULED () { (1<<18); }") unless defined(&ATA_QCFLAG_EH_SCHEDULED);
    eval("sub ATA_HOST_SIMPLEX () { (1<<0); }") unless defined(&ATA_HOST_SIMPLEX);
    eval("sub ATA_TMOUT_BOOT () { 30*HZ; }") unless defined(&ATA_TMOUT_BOOT);
    eval("sub ATA_TMOUT_BOOT_QUICK () { 7*HZ; }") unless defined(&ATA_TMOUT_BOOT_QUICK);
    eval("sub ATA_TMOUT_INTERNAL () { 30*HZ; }") unless defined(&ATA_TMOUT_INTERNAL);
    eval("sub ATA_TMOUT_INTERNAL_QUICK () { 5*HZ; }") unless defined(&ATA_TMOUT_INTERNAL_QUICK);
    eval("sub BUS_UNKNOWN () { 0; }") unless defined(&BUS_UNKNOWN);
    eval("sub BUS_DMA () { 1; }") unless defined(&BUS_DMA);
    eval("sub BUS_IDLE () { 2; }") unless defined(&BUS_IDLE);
    eval("sub BUS_NOINTR () { 3; }") unless defined(&BUS_NOINTR);
    eval("sub BUS_NODATA () { 4; }") unless defined(&BUS_NODATA);
    eval("sub BUS_TIMER () { 5; }") unless defined(&BUS_TIMER);
    eval("sub BUS_PIO () { 6; }") unless defined(&BUS_PIO);
    eval("sub BUS_EDD () { 7; }") unless defined(&BUS_EDD);
    eval("sub BUS_IDENTIFY () { 8; }") unless defined(&BUS_IDENTIFY);
    eval("sub BUS_PACKET () { 9; }") unless defined(&BUS_PACKET);
    eval("sub PORT_UNKNOWN () { 0; }") unless defined(&PORT_UNKNOWN);
    eval("sub PORT_ENABLED () { 1; }") unless defined(&PORT_ENABLED);
    eval("sub PORT_DISABLED () { 2; }") unless defined(&PORT_DISABLED);
    eval("sub ATA_BITS_PIO () { 5; }") unless defined(&ATA_BITS_PIO);
    eval("sub ATA_BITS_MWDMA () { 3; }") unless defined(&ATA_BITS_MWDMA);
    eval("sub ATA_BITS_UDMA () { 8; }") unless defined(&ATA_BITS_UDMA);
    eval("sub ATA_SHIFT_PIO () { 0; }") unless defined(&ATA_SHIFT_PIO);
    eval("sub ATA_SHIFT_MWDMA () { ATA_SHIFT_PIO+ATA_BITS_PIO; }") unless defined(&ATA_SHIFT_MWDMA);
    eval("sub ATA_SHIFT_UDMA () { ATA_SHIFT_MWDMA+ATA_BITS_MWDMA; }") unless defined(&ATA_SHIFT_UDMA);
    eval("sub ATA_MASK_PIO () { ((1<<ATA_BITS_PIO)-1)<<ATA_SHIFT_PIO; }") unless defined(&ATA_MASK_PIO);
    eval("sub ATA_MASK_MWDMA () { ((1<<ATA_BITS_MWDMA)-1)<<ATA_SHIFT_MWDMA; }") unless defined(&ATA_MASK_MWDMA);
    eval("sub ATA_MASK_UDMA () { ((1<<ATA_BITS_UDMA)-1)<<ATA_SHIFT_UDMA; }") unless defined(&ATA_MASK_UDMA);
    eval("sub ATA_DMA_PAD_SZ () { 4; }") unless defined(&ATA_DMA_PAD_SZ);
    eval("sub ATA_DMA_PAD_BUF_SZ () { ATA_DMA_PAD_SZ*ATA_MAX_QUEUE; }") unless defined(&ATA_DMA_PAD_BUF_SZ);
    eval("sub ATA_PORT_PRIMARY () { (1<<0); }") unless defined(&ATA_PORT_PRIMARY);
    eval("sub ATA_PORT_SECONDARY () { (1<<1); }") unless defined(&ATA_PORT_SECONDARY);
    eval("sub ATA_ERING_SIZE () { 32; }") unless defined(&ATA_ERING_SIZE);
    eval("sub ATA_EH_DESC_LEN () { 80; }") unless defined(&ATA_EH_DESC_LEN);
    eval("sub ATA_EH_REVALIDATE () { (1<<0); }") unless defined(&ATA_EH_REVALIDATE);
    eval("sub ATA_EH_SOFTRESET () { (1<<1); }") unless defined(&ATA_EH_SOFTRESET);
    eval("sub ATA_EH_HARDRESET () { (1<<2); }") unless defined(&ATA_EH_HARDRESET);
    eval("sub ATA_EH_SUSPEND () { (1<<3); }") unless defined(&ATA_EH_SUSPEND);
    eval("sub ATA_EH_RESUME () { (1<<4); }") unless defined(&ATA_EH_RESUME);
    eval("sub ATA_EH_PM_FREEZE () { (1<<5); }") unless defined(&ATA_EH_PM_FREEZE);
    eval("sub ATA_EH_RESET_MASK () { ATA_EH_SOFTRESET|ATA_EH_HARDRESET; }") unless defined(&ATA_EH_RESET_MASK);
    eval("sub ATA_EH_PERDEV_MASK () { ATA_EH_REVALIDATE|ATA_EH_SUSPEND|ATA_EH_RESUME|ATA_EH_PM_FREEZE; }") unless defined(&ATA_EH_PERDEV_MASK);
    eval("sub ATA_EHI_HOTPLUGGED () { (1<<0); }") unless defined(&ATA_EHI_HOTPLUGGED);
    eval("sub ATA_EHI_RESUME_LINK () { (1<<1); }") unless defined(&ATA_EHI_RESUME_LINK);
    eval("sub ATA_EHI_NO_AUTOPSY () { (1<<2); }") unless defined(&ATA_EHI_NO_AUTOPSY);
    eval("sub ATA_EHI_QUIET () { (1<<3); }") unless defined(&ATA_EHI_QUIET);
    eval("sub ATA_EHI_DID_RESET () { (1<<16); }") unless defined(&ATA_EHI_DID_RESET);
    eval("sub ATA_EHI_RESET_MODIFIER_MASK () { ATA_EHI_RESUME_LINK; }") unless defined(&ATA_EHI_RESET_MODIFIER_MASK);
    eval("sub ATA_EH_MAX_REPEAT () { 5; }") unless defined(&ATA_EH_MAX_REPEAT);
    eval("sub ATA_PROBE_MAX_TRIES () { 3; }") unless defined(&ATA_PROBE_MAX_TRIES);
    eval("sub ATA_EH_RESET_TRIES () { 3; }") unless defined(&ATA_EH_RESET_TRIES);
    eval("sub ATA_EH_DEV_TRIES () { 3; }") unless defined(&ATA_EH_DEV_TRIES);
    eval("sub ATA_SPINUP_WAIT () { 8000; }") unless defined(&ATA_SPINUP_WAIT);
    eval("sub HSM_ST_UNKNOWN () { 0; }") unless defined(&HSM_ST_UNKNOWN);
    eval("sub HSM_ST_IDLE () { 1; }") unless defined(&HSM_ST_IDLE);
    eval("sub HSM_ST () { 2; }") unless defined(&HSM_ST);
    eval("sub HSM_ST_LAST () { 3; }") unless defined(&HSM_ST_LAST);
    eval("sub HSM_ST_ERR () { 4; }") unless defined(&HSM_ST_ERR);
    eval("sub HSM_ST_FIRST () { 5; }") unless defined(&HSM_ST_FIRST);
    eval("sub AC_ERR_DEV () { (1<<0); }") unless defined(&AC_ERR_DEV);
    eval("sub AC_ERR_HSM () { (1<<1); }") unless defined(&AC_ERR_HSM);
    eval("sub AC_ERR_TIMEOUT () { (1<<2); }") unless defined(&AC_ERR_TIMEOUT);
    eval("sub AC_ERR_MEDIA () { (1<<3); }") unless defined(&AC_ERR_MEDIA);
    eval("sub AC_ERR_ATA_BUS () { (1<<4); }") unless defined(&AC_ERR_ATA_BUS);
    eval("sub AC_ERR_HOST_BUS () { (1<<5); }") unless defined(&AC_ERR_HOST_BUS);
    eval("sub AC_ERR_SYSTEM () { (1<<6); }") unless defined(&AC_ERR_SYSTEM);
    eval("sub AC_ERR_INVALID () { (1<<7); }") unless defined(&AC_ERR_INVALID);
    eval("sub AC_ERR_OTHER () { (1<<8); }") unless defined(&AC_ERR_OTHER);
    eval 'sub ATA_DEVICE_CLEAR_OFFSET { &offsetof(\'struct ata_device\',  &n_sectors);}' unless defined(&ATA_DEVICE_CLEAR_OFFSET);
    eval 'sub FIT {
        my($v,$vmin,$vmax) = @_;
	    eval q( &max_t(\'short\', &min_t(\'short\',$v,$vmax),$vmin));
    }' unless defined(&FIT);
    eval 'sub sata_ehc_deb_timing {
        my($ehc) = @_;
	    eval q({  &if ( ($ehc->{i}->{flags}) &  &ATA_EHI_HOTPLUGGED)  &sata_deb_timing_hotplug;  &else  &sata_deb_timing_normal; });
    }' unless defined(&sata_ehc_deb_timing);
    if(defined(&CONFIG_PCI)) {
    }
    eval("sub ATA_TIMING_SETUP () { (1<<0); }") unless defined(&ATA_TIMING_SETUP);
    eval("sub ATA_TIMING_ACT8B () { (1<<1); }") unless defined(&ATA_TIMING_ACT8B);
    eval("sub ATA_TIMING_REC8B () { (1<<2); }") unless defined(&ATA_TIMING_REC8B);
    eval("sub ATA_TIMING_CYC8B () { (1<<3); }") unless defined(&ATA_TIMING_CYC8B);
    eval("sub ATA_TIMING_8BIT () { ATA_TIMING_ACT8B|ATA_TIMING_REC8B|ATA_TIMING_CYC8B; }") unless defined(&ATA_TIMING_8BIT);
    eval("sub ATA_TIMING_ACTIVE () { (1<<4); }") unless defined(&ATA_TIMING_ACTIVE);
    eval("sub ATA_TIMING_RECOVER () { (1<<5); }") unless defined(&ATA_TIMING_RECOVER);
    eval("sub ATA_TIMING_CYCLE () { (1<<6); }") unless defined(&ATA_TIMING_CYCLE);
    eval("sub ATA_TIMING_UDMA () { (1<<7); }") unless defined(&ATA_TIMING_UDMA);
    eval("sub ATA_TIMING_ALL () { ATA_TIMING_SETUP|ATA_TIMING_ACT8B|ATA_TIMING_REC8B|ATA_TIMING_CYC8B|ATA_TIMING_ACTIVE|ATA_TIMING_RECOVER|ATA_TIMING_CYCLE|ATA_TIMING_UDMA; }") unless defined(&ATA_TIMING_ALL);
    if(defined(&CONFIG_PCI)) {
    }
    eval 'sub ata_port_printk {( &ap,  &lv,  &fmt,  &args...)  &printk( &lv"ata%u: " &fmt, ( &ap)-> &id ,  &args);}' unless defined(&ata_port_printk);
    eval 'sub ata_dev_printk {( &dev,  &lv,  &fmt,  &args...)  &printk( &lv"ata%u.%02u: " &fmt, ( &dev)-> ($ap->{id}), ( &dev)-> &devno ,  &args);}' unless defined(&ata_dev_printk);
    eval 'sub ata_ehi_push_desc {( &ehi,  &fmt,  &args...)  &do { ( &ehi)-> &desc_len +=  &scnprintf(( &ehi)-> &desc + ( &ehi)-> &desc_len,  &ATA_EH_DESC_LEN - ( &ehi)-> &desc_len,  &fmt ,  &args); }  &while (0);}' unless defined(&ata_ehi_push_desc);
    eval 'sub ata_ehi_clear_desc {
        my($ehi) = @_;
	    eval q( &do { ($ehi)-> $desc[0] = ord(\'\\\\0\'); ($ehi)-> &desc_len = 0; }  &while (0));
    }' unless defined(&ata_ehi_clear_desc);
    eval 'sub __ata_ehi_hotplugged {
        my($ehi) = @_;
	    eval q({  &if ( ($ehi->{flags}) &  &ATA_EHI_HOTPLUGGED) ;  ($ehi->{flags}) |=  &ATA_EHI_HOTPLUGGED |  &ATA_EHI_RESUME_LINK;  ($ehi->{hotplug_timestamp}) =  &jiffies;  ($ehi->{action}) |=  &ATA_EH_SOFTRESET;  ($ehi->{probe_mask}) |= (1<<  &ATA_MAX_DEVICES) - 1; });
    }' unless defined(&__ata_ehi_hotplugged);
    eval 'sub ata_ehi_hotplugged {
        my($ehi) = @_;
	    eval q({  &__ata_ehi_hotplugged($ehi);  ($ehi->{err_mask}) |=  &AC_ERR_ATA_BUS; });
    }' unless defined(&ata_ehi_hotplugged);
    eval 'sub ata_qc_first_sg {
        my($qc) = @_;
	    eval q({  &if ( ($qc->{n_elem}))  ($qc->{__sg});  &if ( ($qc->{pad_len}))  ($qc->{pad_sgent});  &NULL; });
    }' unless defined(&ata_qc_first_sg);
    eval 'sub ata_qc_next_sg {
        my($sg,$qc) = @_;
	    eval q({  &if ($sg ==  ($qc->{pad_sgent}))  &NULL;  &if (++$sg -  ($qc->{__sg}) <  ($qc->{n_elem})) $sg;  &if ( ($qc->{pad_len}))  ($qc->{pad_sgent});  &NULL; });
    }' unless defined(&ata_qc_next_sg);
    eval 'sub ata_for_each_sg {
        my($sg, $qc) = @_;
	    eval q( &for ($sg =  &ata_qc_first_sg($qc); $sg; $sg =  &ata_qc_next_sg($sg, $qc)));
    }' unless defined(&ata_for_each_sg);
    eval 'sub ata_tag_valid {
        my($tag) = @_;
	    eval q({ ($tag <  &ATA_MAX_QUEUE) ? 1: 0; });
    }' unless defined(&ata_tag_valid);
    eval 'sub ata_tag_internal {
        my($tag) = @_;
	    eval q({ $tag ==  &ATA_MAX_QUEUE - 1; });
    }' unless defined(&ata_tag_internal);
    eval 'sub ata_class_disabled {
        my($class) = @_;
	    eval q({ $class ==  &ATA_DEV_ATA_UNSUP || $class ==  &ATA_DEV_ATAPI_UNSUP; });
    }' unless defined(&ata_class_disabled);
    eval 'sub ata_class_absent {
        my($class) = @_;
	    eval q({ ! &ata_class_enabled($class)  && ! &ata_class_disabled($class); });
    }' unless defined(&ata_class_absent);
    eval 'sub ata_dev_enabled {
        my($dev) = @_;
	    eval q({  &ata_class_enabled( ($dev->{class})); });
    }' unless defined(&ata_dev_enabled);
    eval 'sub ata_dev_disabled {
        my($dev) = @_;
	    eval q({  &ata_class_disabled( ($dev->{class})); });
    }' unless defined(&ata_dev_disabled);
    eval 'sub ata_dev_absent {
        my($dev) = @_;
	    eval q({  &ata_class_absent( ($dev->{class})); });
    }' unless defined(&ata_dev_absent);
    eval 'sub ata_dev_ready {
        my($dev) = @_;
	    eval q({  &ata_dev_enabled($dev)  && !( ($dev->{flags}) &  &ATA_DFLAG_SUSPENDED); });
    }' unless defined(&ata_dev_ready);
    eval 'sub ata_chk_status {
        my($ap) = @_;
	    eval q({  ($ap->{ops}->{check_status})($ap); });
    }' unless defined(&ata_chk_status);
    eval 'sub ata_qc_set_polling {
        my($qc) = @_;
	    eval q({  ($qc->{tf}->{ctl}) |=  &ATA_NIEN; });
    }' unless defined(&ata_qc_set_polling);
    eval 'sub ata_queued_cmd {
        eval q(* &__ata_qc_from_tag(\'struct ata_port\' * &ap, my $tag) {  &if ( &likely( &ata_tag_valid( $tag)))  ($ap->{qcmd[$tag]});  &NULL; });
    }' unless defined(&ata_queued_cmd);
    eval 'sub ata_queued_cmd {
        eval q(* &ata_qc_from_tag(\'struct ata_port\' * &ap, my $tag) { \'struct ata_queued_cmd\' * &qc =  &__ata_qc_from_tag( &ap,  $tag);  &if ( &unlikely(! &qc) || ! ($ap->{ops}->{error_handler}))  &qc;  &if (( ($qc->{flags}) & ( &ATA_QCFLAG_ACTIVE |  &ATA_QCFLAG_FAILED)) ==  &ATA_QCFLAG_ACTIVE)  &qc;  &NULL; });
    }' unless defined(&ata_queued_cmd);
    eval 'sub ata_tf_init {
        my($dev,$tf) = @_;
	    eval q({  &memset($tf, 0, $sizeof{$tf});  ($tf->{ctl}) =  ($dev->{ap}->{ctl});  &if ( ($dev->{devno}) == 0)  ($tf->{device}) =  &ATA_DEVICE_OBS;  &else  ($tf->{device}) =  &ATA_DEVICE_OBS |  &ATA_DEV1; });
    }' unless defined(&ata_tf_init);
    eval 'sub ata_qc_reinit {
        my($qc) = @_;
	    eval q({  ($qc->{__sg}) =  &NULL;  ($qc->{flags}) = 0;  ($qc->{cursect}) =  ($qc->{cursg}) =  ($qc->{cursg_ofs}) = 0;  ($qc->{nsect}) = 0;  ($qc->{nbytes}) =  ($qc->{curbytes}) = 0;  ($qc->{err_mask}) = 0;  &ata_tf_init( ($qc->{dev}),  ($qc->{tf}));  ($qc->{result_tf}->{command}) =  &ATA_DRDY;  ($qc->{result_tf}->{feature}) = 0; });
    }' unless defined(&ata_qc_reinit);
    eval 'sub ata_try_flush_cache {
        my($dev) = @_;
	    eval q({  &ata_id_wcache_enabled( ($dev->{id})) ||  &ata_id_has_flush( ($dev->{id})) ||  &ata_id_has_flush_ext( ($dev->{id})); });
    }' unless defined(&ata_try_flush_cache);
    eval 'sub ac_err_mask {
        my($status) = @_;
	    eval q({  &if ($status & ( &ATA_BUSY |  &ATA_DRQ))  &AC_ERR_HSM;  &if ($status & ( &ATA_ERR |  &ATA_DF))  &AC_ERR_DEV; 0; });
    }' unless defined(&ac_err_mask);
    eval 'sub __ac_err_mask {
        my($status) = @_;
	    eval q({ my $mask =  &ac_err_mask($status);  &if ( $mask == 0)  &AC_ERR_OTHER;  $mask; });
    }' unless defined(&__ac_err_mask);
    eval 'sub ata_pad_alloc {
        my($ap,$dev) = @_;
	    eval q({  ($ap->{pad_dma}) = 0;  ($ap->{pad}) =  &dma_alloc_coherent($dev,  &ATA_DMA_PAD_BUF_SZ,  ($ap->{pad_dma}),  &GFP_KERNEL); ( ($ap->{pad}) ==  &NULL) ? - &ENOMEM : 0; });
    }' unless defined(&ata_pad_alloc);
    eval 'sub ata_pad_free {
        my($ap,$dev) = @_;
	    eval q({  &dma_free_coherent($dev,  &ATA_DMA_PAD_BUF_SZ,  ($ap->{pad}),  ($ap->{pad_dma})); });
    }' unless defined(&ata_pad_free);
    eval 'sub ata_port {
        eval q(* &ata_shost_to_port(\'struct Scsi_Host\' * &host) {   ($host->{hostdata[0]}); });
    }' unless defined(&ata_port);
}
1;
